-- sem.ads --- Semaphores
-- Author          : Burns & Wellings
-- Created On      : Wed Jan 21 16:27:12 1998
-- Last Modified By: Fco. J. Ballesteros
-- Last Modified On: Wed Jan 21 16:31:18 1998
-- Update Count    : 8
-- VC Id           : $Id$ 
-- Usage           : 
--                 : Simple general semaphores:
--                 :  Mutex: Semaphore(1);
--                 :  ...
--                 :  Mutex.Down();
--                 :  -- critical region ...
--                 :  Mutex.Up();
-- Status          : Adapted from "Concurrency in Ada" by nemo@gsyc.inf.uc3m.es
-- 

package body Semaphores is

   protected body Semaphore is 

      -- Release a slot (V or signal).
      procedure Up is 
      begin 
         FreeSlots := FreeSlots+1;
      end Up;

      -- Request a free slot (P or wait).
      entry Down when FreeSlots > 0 is
      begin
         FreeSlots := FreeSlots-1;
      end Down;
   end Semaphore;
end Semaphores;
