-- sem.ads --- Semaphores
-- Author          : Burns & Wellings
-- Created On      : Wed Jan 21 16:27:12 1998
-- Last Modified By: Fco. J. Ballesteros
-- Last Modified On: Wed Jan 21 16:30:07 1998
-- Update Count    : 4
-- VC Id           : $Id$ 
-- Usage           : 
--                 : Simple general semaphores:
--                 :  Mutex: Semaphore(1);
--                 :  ...
--                 :  Mutex.Down();
--                 :  -- critical region ...
--                 :  Mutex.Up();
-- Status          : Adapted from "Concurrency in Ada" by nemo@gsyc.inf.uc3m.es
-- 


package Semaphores is

   -- A semaphore with InitialFreeSlots free slots.
   --
   protected type Semaphore(InitialFreeSlots: Natural := 0) is 
      procedure Up;                     -- V or signal
      entry Down;                       -- P or wait
   private
      FreeSlots: Natural := InitialFreeSlots;
   end Semaphore;
end Semaphores;
