   -- Procedimiento que averigua el camino completo para
   -- el fichero que corresponde a un comando. Para ello emplea internamente
   -- el comando `which' que a su vez mira en el PATH.
   -- Ejemplo:
   --        Which("ls",2,Buffer,BufferLength);
   --        ---> deja en Buffer "/bin/ls" y en BufferLength 7
   -- Nota: BufferLength se inicializa (antes de llamar a Which) con
   --       el numero maximo de caracteres que puede almacenar Buffer.
   --
   procedure Which(Cmd: in String; CmdLen: in Positive;
                   File: out String; FileLen: in out Positive) is
      Wpipe : Unix.T_Fildes;
      Pid   : Natural;
      Status: aliased Natural;
   begin
      Unix.Pipe(Wpipe);
      Pid := Unix.Fork;
      case Pid is
         when 0 =>
            Unix.Close(Wpipe(0));
            Unix.Close(Stdout);
            Wpipe(0) := Unix.Dup(Wpipe(1));
            Unix.Execlp( "/usr/bin/which",
                         "which",
                         Cmd(1..CmdLen));
         when others =>
            Unix.Close(Wpipe(1));
            Pid := Unix.Wait(Status'Unchecked_Access);
            if Status = 0 then
               Unix.Read(Wpipe(0),File,FileLen,FileLen);
               FileLen := FileLen - 1;
               Unix.Close(Wpipe(0));
            else
               Unix.Close(Wpipe(0));
               raise Unix.ENOEXEC;
            end if;
      end case;
   end;
